///////////////////////////////////////////////////////////////
// Tracker Add-on Example
// by Peter Hinely <phinely@hawaii.edu>
//
// Demonstration of how to migrate the functionality of a 
// Tracker add-on to a separate application so that Tracker 
// stability is not jepardized by bugs in the add-on
///////////////////////////////////////////////////////////////

#include "main.h"
#include "App.h"
#include <TrackerAddOn.h> 

int main() {
	App theApp;
	theApp.Run();
	return B_OK;
}

// this function is called by the Tracker when this add-on is invoked
void process_refs(entry_ref dir_ref, BMessage *message, void *) {
	switch(be_roster->Launch(FILE_SIGNATURE, message)) { // launch this program as an application and send it the refs message
		case B_OK: { // launched okay - do nothing
			break;
		}
		case B_BAD_VALUE: {
			BAlert *alert = new BAlert("BAlert", "Could not launch the application corresponding to the Tracker add-on.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT); 
			alert->Go();
			break;
		}
		case B_ALREADY_RUNNING: { // already running - do nothing
			break;
		}
		case B_LAUNCH_FAILED: {
			BAlert *alert = new BAlert("BAlert", "Could not launch the application corresponding to the Tracker add-on.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT); 
			alert->Go();
			break;
		}
		default: { // a file system error
			BAlert *alert = new BAlert("BAlert", "Could not launch the application corresponding to the Tracker add-on.", "OK", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT); 
			alert->Go();
			break;
		}
	}
}

